import java.util.*;

public class FOLResolution {
    public static void main(String[] args) {
        Resolver resolver = new Resolver();

        // Example clauses in CNF
        // Clause clause1 = new Clause(Arrays.asList(
                // new Predicate("P", Arrays.asList(new Term("a", false)), false), // P(a)
                // new Predicate("Q", Arrays.asList(new Term("b", false)), true))); // ~Q(b)

        // Clause clause2 = new Clause(Arrays.asList(
                // new Predicate("P", Arrays.asList(new Term("x", true)), true),  // ~P(x)
                // new Predicate("Q", Arrays.asList(new Term("y", true)), false))); // Q(y)

        // resolver.addClause(clause1);
        // resolver.addClause(clause2);

        // Goal to resolve (~P(a) OR Q(b))
        // Clause goal = new Clause(Arrays.asList(
                // new Predicate("P", Arrays.asList(new Term("a", false)), true),  // ~P(a)
                // new Predicate("Q", Arrays.asList(new Term("b", false)), false))); // Q(b)

        // boolean result = resolver.resolve(goal);
		
		// Clause 1: ¬Loves(x, Animal) ∨ Owns(x, Dog)
        Clause clause1 = new Clause(Arrays.asList(
                new Predicate("Loves", Arrays.asList(new Term("x", true), new Term("Animal", false)), true), // ¬Loves(x, Animal)
                new Predicate("Owns", Arrays.asList(new Term("x", true), new Term("Dog", false)), false)     // Owns(x, Dog)
        ));

        // Clause 2: ¬Kills(x, Animal) ∨ ¬Loves(x, Animal)
        Clause clause2 = new Clause(Arrays.asList(
                new Predicate("Kills", Arrays.asList(new Term("x", true), new Term("Animal", false)), true), // ¬Kills(x, Animal)
                new Predicate("Loves", Arrays.asList(new Term("x", true), new Term("Animal", false)), true)  // ¬Loves(x, Animal)
        ));

        // Clause 3: ¬Kills(John, Animal)
        Clause clause3 = new Clause(Arrays.asList(
                new Predicate("Kills", Arrays.asList(new Term("John", false), new Term("Animal", false)), true) // ¬Kills(John, Animal)
        ));

        // Clause 4: Loves(x, Animal) ∨ Kills(x, Animal)
        Clause clause4 = new Clause(Arrays.asList(
                new Predicate("Loves", Arrays.asList(new Term("x", true), new Term("Animal", false)), false), // Loves(x, Animal)
                new Predicate("Kills", Arrays.asList(new Term("x", true), new Term("Animal", false)), false)  // Kills(x, Animal)
        ));

        // Negated goal: ¬Owns(John, Dog)
        Clause negatedGoal = new Clause(Arrays.asList(
                new Predicate("Owns", Arrays.asList(new Term("John", false), new Term("Dog", false)), true) // ¬Owns(John, Dog)
        ));

        // Add premises to knowledge base
        resolver.addClause(clause1);
        resolver.addClause(clause2);
        resolver.addClause(clause3);
        resolver.addClause(clause4);

        // Resolve with negated goal
        boolean result = resolver.resolve(negatedGoal);

        if (result) {
            System.out.println("Contradiction found: Goal is derivable.");
        } else {
            System.out.println("No contradiction: Goal is not derivable.");
        }
    }
}