import java.util.ArrayList;
import java.util.HashMap;

public class FOLTesting extends FOLLoader {
    public void example(String filename) {
        System.out.println("Example: Reading the FOL Knowledge Base; using KB_FOL_RES.txt");
        this.initialize(filename);

        Resolver resolver = new Resolver();
        ArrayList<Clause> KB = FOLLoader.KB.getTValue();
        resolver.updateKB(KB);

        Clause goal = FOLLoader.KB.getYValue();
        if (goal.getPredicates().size() > 1) { System.out.println("Wrong file format!"); }
        else { goal.getPredicates().get(0).negate(); }

        boolean result = resolver.resolve(goal);

        if (result) {
            System.out.println("Contradiction found: Goal is derivable.");
        } else {
            System.out.println("No contradiction: Goal is not derivable.");
        }
    }

    public static void main(String[] args) {
        FOLTesting f = new FOLTesting();
        f.example("C:\\Users\\Georgios Moschovis\\Desktop\\FOLResolution\\KB_FOL_RES.txt");
    }
}
